#ifndef KITEBOOLEAN_H
#define KITEBOOLEAN_H

#include <string>
#include "KiteObject.h"

class KiteBoolean : public KiteObject {
public:
	KiteBoolean()
		: KiteObject(true) {
        inherits = KiteObject::getClassinfo();
        type = "boolean";
		initialize();
	}

	KiteBoolean(std::string str) : KiteObject(true), instance(true) { 
        type = "boolean";
		initialize();
        inherits = KiteObject::getClassinfo();
		if (str == "true") val = true;
		else val = false;
	}

	KiteBoolean(bool value) : KiteObject(true), instance(true) { 
        type = "boolean";
		initialize();
        inherits = KiteObject::getClassinfo();
		val = value;
	}

	bool boolVal() { return val; }

	/*virtual KiteReference<KiteObject> call(VM &vm, KiteObject &param);
	virtual KiteReference<KiteObject> dereference(VM &vm, KiteIdentifier &id);*/
private:
	bool val;
	bool instance;
	void initialize();
};

#endif // KITEBOOLEAN_H
