#ifndef KITECODE_H
#define KITECODE_H

#include "KiteVM.h"
#include "KiteObject.h"

using namespace KiteVM;

class KiteCode : public KiteObject {
public:
	KiteCode() : KiteObject(true), instance(false) {
        inherits = KiteObject::getClassinfo();
        type = "code";
		initialize();
	}

	KiteCode(KiteReference<KiteObject> (*ptr)(VM &, KiteReference<KiteObject>))
		: KiteObject(false), instance(true), funcPtr(ptr), instr(NULL) {
        inherits = NULL;
        type = "code";
    }

	KiteCode(Instruction *ins)
		: KiteObject(true), funcPtr(NULL), instr(ins) {
        inherits = KiteObject::getClassinfo();
        type = "code";
		initialize();
    }

	virtual ~KiteCode();

	virtual KiteReference<KiteObject> call(KiteVM::VM &vm, KiteReference<KiteObject> param);
	Instruction *getCode() { return instr; }
private:
	KiteReference<KiteObject> (*funcPtr)(KiteVM::VM &, KiteReference<KiteObject>);
	Instruction *instr;
	bool instance;

	void initialize();
};

#endif // KITECODE_H
