#ifndef KITESTRING_H
#define KITESTRING_H

#include <string>
#include "KiteObject.h"

class KiteString : public KiteObject {
public:
	KiteString()
		: KiteObject(true) {
        inherits = KiteObject::getClassinfo();
        type = "string";
		initialize();
	}

	KiteString(std::string str) : KiteObject(true),
		instance(true), string(str) {
        inherits = KiteObject::getClassinfo();
        type = "string";
		initialize();
    }

	/*virtual KiteReference<KiteObject> call(VM &vm, KiteObject &param);
	virtual KiteReference<KiteObject> dereference(VM &vm, KiteIdentifier &id);*/

	virtual bool operator<(const KiteString &rhs) const {
		return string < rhs.string;
	}

	virtual bool operator<(const KiteObject &rhs) const {
		return operator<(dynamic_cast<const KiteString&>(rhs));
	}

	virtual bool operator==(const KiteString &rhs) const {
		return string == rhs.string;
	}

	std::string getString() { return string; }
private:
	std::string string;
	bool instance;
	void initialize();
};

#endif // KITESTRING_H
