#include "SymbolTable.h"
#include "KiteVM.h"
#include "KiteObject.h"
#include "KiteIdentifier.h"

SymbolTable::SymbolTable() {
	addContext();
}

SymbolTable::~SymbolTable() {
	// none needed
}

void SymbolTable::addContext() {
	syms.insert(syms.begin(), map<KiteIdentifier, KiteReference<KiteObject> >());
}

void SymbolTable::removeContext() {
	syms.erase(syms.begin());
}

void SymbolTable::addVar(KiteReference<KiteIdentifier> id, KiteReference<KiteObject> val) {
	(syms.at(0))[*id] = val;
}

KiteReference<KiteObject> SymbolTable::get(KiteReference<KiteIdentifier> id) {
	unsigned int i;

	for (i = 0; i < syms.size(); i++) {
		if ((syms.at(i)).count(*id) > 0) 
			return (syms.at(i))[*id];
	}

	return (syms.at(0))[*id];
}

KiteReference<KiteObject> SymbolTable::replace(KiteReference<KiteIdentifier> id, KiteReference<KiteObject> newval) {
	unsigned int i;

	for (i = 0; i < syms.size(); i++) {
		if ((syms.at(i)).count(*id) > 0) {
			(syms.at(i)).erase(*id);
			(syms.at(i))[*id] = newval;
			return newval;
		}
	}

	(syms.at(0))[*id] = newval;
	return newval;
}

bool SymbolTable::exists(KiteReference<KiteIdentifier> id) {
    for (int i = 0; i < syms.size(); i++) {
		if ((syms.at(i)).count(*id) > 0) 
			return true;
	}

	return false;
}
