#ifndef SYMBOLTABLE_H
#define SYMBOLTABLE_H

#include <map>
#include <vector>
#include "KiteReference.h"

using namespace std;
class KiteIdentifier;
class KiteObject;

class SymbolTable {
public:
	SymbolTable();
	virtual ~SymbolTable();

	void addContext();
	void removeContext();
	void addVar(KiteReference<KiteIdentifier> id, KiteReference<KiteObject> val);
	KiteReference<KiteObject> get(KiteReference<KiteIdentifier> id);
	KiteReference<KiteObject> replace(KiteReference<KiteIdentifier> id, KiteReference<KiteObject> newval);
    bool exists(KiteReference<KiteIdentifier> id);
    
	map<KiteIdentifier, KiteReference<KiteObject> > &getTop() { return syms.at(0); }
private:
	vector<map<KiteIdentifier, KiteReference<KiteObject> > > syms;
};

#endif // SYMBOLTABLE_H
